import { ATN, DFA, FailedPredicateException, Parser, ParserRuleContext, TerminalNode, TokenStream } from 'antlr4';
export default class OptionalsParser extends Parser {
    static readonly SPACE = 1;
    static readonly A = 2;
    static readonly B = 3;
    static readonly C = 4;
    static readonly D = 5;
    static readonly E = 6;
    static readonly F = 7;
    static readonly G = 8;
    static readonly H = 9;
    static readonly I = 10;
    static readonly J = 11;
    static readonly K = 12;
    static readonly L = 13;
    static readonly M = 14;
    static readonly N = 15;
    static readonly O = 16;
    static readonly P = 17;
    static readonly Q = 18;
    static readonly R = 19;
    static readonly S = 20;
    static readonly T = 21;
    static readonly U = 22;
    static readonly V = 23;
    static readonly W = 24;
    static readonly Y = 25;
    static readonly Z = 26;
    static readonly AA = 27;
    static readonly BB = 28;
    static readonly CC = 29;
    static readonly DD = 30;
    static readonly EOF: number;
    static readonly RULE_expression = 0;
    static readonly RULE_ruleOne = 1;
    static readonly RULE_ruleTwo = 2;
    static readonly RULE_ruleThree = 3;
    static readonly RULE_ruleFour = 4;
    static readonly RULE_ruleFive = 5;
    static readonly RULE_ruleSix = 6;
    static readonly RULE_ruleSeven = 7;
    static readonly RULE_ruleEight = 8;
    static readonly RULE_ruleNine = 9;
    static readonly RULE_ruleTen = 10;
    static readonly RULE_ruleEleven = 11;
    static readonly RULE_ruleTwelve = 12;
    static readonly RULE_ruleThirteen = 13;
    static readonly RULE_ruleFourTeen = 14;
    static readonly RULE_ruleFifTeen = 15;
    static readonly RULE_ruleSixteen = 16;
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly ruleNames: string[];
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    constructor(input: TokenStream);
    expression(): ExpressionContext;
    ruleOne(): RuleOneContext;
    ruleTwo(): RuleTwoContext;
    ruleThree(): RuleThreeContext;
    ruleFour(): RuleFourContext;
    ruleFive(): RuleFiveContext;
    ruleSix(): RuleSixContext;
    ruleSeven(): RuleSevenContext;
    ruleEight(): RuleEightContext;
    ruleNine(): RuleNineContext;
    ruleTen(): RuleTenContext;
    ruleEleven(): RuleElevenContext;
    ruleTwelve(): RuleTwelveContext;
    ruleThirteen(): RuleThirteenContext;
    ruleFourTeen(): RuleFourTeenContext;
    ruleFifTeen(): RuleFifTeenContext;
    ruleSixteen(): RuleSixteenContext;
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): ATN;
    static DecisionsToDFA: DFA[];
}
export declare class ExpressionContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    ruleOne(): RuleOneContext;
    ruleTwo(): RuleTwoContext;
    ruleThree(): RuleThreeContext;
    ruleFour(): RuleFourContext;
    ruleFive(): RuleFiveContext;
    ruleSix(): RuleSixContext;
    ruleSeven(): RuleSevenContext;
    ruleEight(): RuleEightContext;
    ruleNine(): RuleNineContext;
    ruleTen(): RuleTenContext;
    ruleEleven(): RuleElevenContext;
    ruleTwelve(): RuleTwelveContext;
    ruleThirteen(): RuleThirteenContext;
    ruleFourTeen(): RuleFourTeenContext;
    ruleFifTeen(): RuleFifTeenContext;
    ruleSixteen(): RuleSixteenContext;
    get ruleIndex(): number;
}
export declare class RuleOneContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    A(): TerminalNode;
    B(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleTwoContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    D(): TerminalNode;
    C(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleThreeContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    E(): TerminalNode;
    F(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleFourContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    H(): TerminalNode;
    G(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleFiveContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    I(): TerminalNode;
    J(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleSixContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    L(): TerminalNode;
    K_list(): TerminalNode[];
    K(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleSevenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    M(): TerminalNode;
    N_list(): TerminalNode[];
    N(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleEightContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    P(): TerminalNode;
    O_list(): TerminalNode[];
    O(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleNineContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    Q(): TerminalNode;
    R_list(): TerminalNode[];
    R(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleTenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    T(): TerminalNode;
    S_list(): TerminalNode[];
    S(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleElevenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    U(): TerminalNode;
    V_list(): TerminalNode[];
    V(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleTwelveContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    Y(): TerminalNode;
    W_list(): TerminalNode[];
    W(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleThirteenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    Z(): TerminalNode;
    AA_list(): TerminalNode[];
    AA(i: number): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleFourTeenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    BB(): TerminalNode;
    A(): TerminalNode;
    B(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleFifTeenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    CC(): TerminalNode;
    A(): TerminalNode;
    B(): TerminalNode;
    get ruleIndex(): number;
}
export declare class RuleSixteenContext extends ParserRuleContext {
    constructor(parser?: OptionalsParser, parent?: ParserRuleContext, invokingState?: number);
    DD(): TerminalNode;
    C(): TerminalNode;
    A(): TerminalNode;
    B(): TerminalNode;
    get ruleIndex(): number;
}
